using System;
using System.Windows.Forms;
using ArrayList=System.Collections.ArrayList;
using Path=System.IO.Path;
//TODO: Cell names are null terminated

namespace TESFaith {
    public class MainForm : Form {
        #region FormDesignerGunk
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components=null;
        private Button bOpen;
        private Button bBatch;
        private Button bClose;
        private Panel MapPanel;
        private Button bOverlay;
        private Button bSLeft;
        private Button bSRight;
        private Button bSUp;
        private Button bSDown;
        private Button bClearOverlay;
        private ToolTip ttCellData;
        private Button bMove;
        private Button bCopy;
        private Button bDelete;
        private Button bCellList;
        private Button bMap;
        private SaveFileDialog SaveMapDialog;
        private OpenFileDialog OpenModDialog;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing) {
            if(disposing&&(components!=null)) {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            this.components=new System.ComponentModel.Container();
            this.bOpen=new System.Windows.Forms.Button();
            this.bBatch=new System.Windows.Forms.Button();
            this.OpenModDialog=new System.Windows.Forms.OpenFileDialog();
            this.bClose=new System.Windows.Forms.Button();
            this.MapPanel=new System.Windows.Forms.Panel();
            this.bOverlay=new System.Windows.Forms.Button();
            this.bSLeft=new System.Windows.Forms.Button();
            this.bSRight=new System.Windows.Forms.Button();
            this.bSUp=new System.Windows.Forms.Button();
            this.bSDown=new System.Windows.Forms.Button();
            this.bClearOverlay=new System.Windows.Forms.Button();
            this.ttCellData=new System.Windows.Forms.ToolTip(this.components);
            this.bMove=new System.Windows.Forms.Button();
            this.bCopy=new System.Windows.Forms.Button();
            this.bDelete=new System.Windows.Forms.Button();
            this.bCellList=new System.Windows.Forms.Button();
            this.bMap=new System.Windows.Forms.Button();
            this.SaveMapDialog=new System.Windows.Forms.SaveFileDialog();
            this.SuspendLayout();
            // 
            // bOpen
            // 
            this.bOpen.Location=new System.Drawing.Point(12, 12);
            this.bOpen.Name="bOpen";
            this.bOpen.Size=new System.Drawing.Size(90, 23);
            this.bOpen.TabIndex=0;
            this.bOpen.Text="Open mod";
            this.bOpen.Click+=new System.EventHandler(this.bOpen_Click);
            // 
            // bBatch
            // 
            this.bBatch.Enabled=false;
            this.bBatch.Location=new System.Drawing.Point(204, 12);
            this.bBatch.Name="bBatch";
            this.bBatch.Size=new System.Drawing.Size(90, 23);
            this.bBatch.TabIndex=1;
            this.bBatch.Text="Batch process";
            this.bBatch.Click+=new System.EventHandler(this.bBatch_Click);
            // 
            // OpenModDialog
            // 
            this.OpenModDialog.DefaultExt="esp";
            this.OpenModDialog.Filter="Morrowind plugins (esp/esm)|*.esp;*.esm|All files|*.*";
            this.OpenModDialog.RestoreDirectory=true;
            this.OpenModDialog.Title="Select mod to open";
            // 
            // bClose
            // 
            this.bClose.Enabled=false;
            this.bClose.Location=new System.Drawing.Point(108, 12);
            this.bClose.Name="bClose";
            this.bClose.Size=new System.Drawing.Size(90, 23);
            this.bClose.TabIndex=3;
            this.bClose.Text="Close mod";
            this.bClose.Click+=new System.EventHandler(this.bClose_Click);
            // 
            // MapPanel
            // 
            this.MapPanel.Anchor=((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top|System.Windows.Forms.AnchorStyles.Bottom)
                        |System.Windows.Forms.AnchorStyles.Left)
                        |System.Windows.Forms.AnchorStyles.Right)));
            this.MapPanel.Location=new System.Drawing.Point(12, 41);
            this.MapPanel.Name="MapPanel";
            this.MapPanel.Size=new System.Drawing.Size(570, 313);
            this.MapPanel.TabIndex=4;
            this.MapPanel.MouseLeave+=new System.EventHandler(this.MapPanel_MouseLeave);
            this.MapPanel.MouseDown+=new System.Windows.Forms.MouseEventHandler(this.MapPanel_MouseDown);
            this.MapPanel.MouseMove+=new System.Windows.Forms.MouseEventHandler(this.MapPanel_MouseMove);
            this.MapPanel.Paint+=new System.Windows.Forms.PaintEventHandler(this.MapPanel_Paint);
            // 
            // bOverlay
            // 
            this.bOverlay.Location=new System.Drawing.Point(300, 12);
            this.bOverlay.Name="bOverlay";
            this.bOverlay.Size=new System.Drawing.Size(90, 23);
            this.bOverlay.TabIndex=5;
            this.bOverlay.Text="Overlay plugin";
            this.bOverlay.Click+=new System.EventHandler(this.bOverlay_Click);
            // 
            // bSLeft
            // 
            this.bSLeft.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bSLeft.Location=new System.Drawing.Point(12, 360);
            this.bSLeft.Name="bSLeft";
            this.bSLeft.Size=new System.Drawing.Size(60, 23);
            this.bSLeft.TabIndex=6;
            this.bSLeft.Text="Left";
            this.bSLeft.Click+=new System.EventHandler(this.bScrollClick);
            // 
            // bSRight
            // 
            this.bSRight.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bSRight.Location=new System.Drawing.Point(78, 360);
            this.bSRight.Name="bSRight";
            this.bSRight.Size=new System.Drawing.Size(60, 23);
            this.bSRight.TabIndex=7;
            this.bSRight.Text="Right";
            this.bSRight.Click+=new System.EventHandler(this.bScrollClick);
            // 
            // bSUp
            // 
            this.bSUp.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bSUp.Location=new System.Drawing.Point(144, 360);
            this.bSUp.Name="bSUp";
            this.bSUp.Size=new System.Drawing.Size(60, 23);
            this.bSUp.TabIndex=8;
            this.bSUp.Text="Up";
            this.bSUp.Click+=new System.EventHandler(this.bScrollClick);
            // 
            // bSDown
            // 
            this.bSDown.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bSDown.Location=new System.Drawing.Point(210, 360);
            this.bSDown.Name="bSDown";
            this.bSDown.Size=new System.Drawing.Size(60, 23);
            this.bSDown.TabIndex=9;
            this.bSDown.Text="Down";
            this.bSDown.Click+=new System.EventHandler(this.bScrollClick);
            // 
            // bClearOverlay
            // 
            this.bClearOverlay.Location=new System.Drawing.Point(396, 12);
            this.bClearOverlay.Name="bClearOverlay";
            this.bClearOverlay.Size=new System.Drawing.Size(90, 23);
            this.bClearOverlay.TabIndex=10;
            this.bClearOverlay.Text="Clear overlay";
            this.bClearOverlay.Click+=new System.EventHandler(this.bClearOverlay_Click);
            // 
            // bMove
            // 
            this.bMove.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bMove.Enabled=false;
            this.bMove.Location=new System.Drawing.Point(324, 360);
            this.bMove.Name="bMove";
            this.bMove.Size=new System.Drawing.Size(60, 23);
            this.bMove.TabIndex=11;
            this.bMove.Text="Move";
            this.bMove.Click+=new System.EventHandler(this.bMove_Click);
            // 
            // bCopy
            // 
            this.bCopy.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bCopy.Enabled=false;
            this.bCopy.Location=new System.Drawing.Point(390, 360);
            this.bCopy.Name="bCopy";
            this.bCopy.Size=new System.Drawing.Size(60, 23);
            this.bCopy.TabIndex=12;
            this.bCopy.Text="Copy";
            this.bCopy.Click+=new System.EventHandler(this.bCopy_Click);
            // 
            // bDelete
            // 
            this.bDelete.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bDelete.Enabled=false;
            this.bDelete.Location=new System.Drawing.Point(456, 360);
            this.bDelete.Name="bDelete";
            this.bDelete.Size=new System.Drawing.Size(60, 23);
            this.bDelete.TabIndex=13;
            this.bDelete.Text="Delete";
            this.bDelete.Click+=new System.EventHandler(this.bDelete_Click);
            // 
            // bCellList
            // 
            this.bCellList.Enabled=false;
            this.bCellList.Location=new System.Drawing.Point(492, 12);
            this.bCellList.Name="bCellList";
            this.bCellList.Size=new System.Drawing.Size(90, 23);
            this.bCellList.TabIndex=14;
            this.bCellList.Text="List Cells";
            this.bCellList.Click+=new System.EventHandler(this.bCellList_Click);
            // 
            // bMap
            // 
            this.bMap.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom|System.Windows.Forms.AnchorStyles.Left)));
            this.bMap.Location=new System.Drawing.Point(522, 360);
            this.bMap.Name="bMap";
            this.bMap.Size=new System.Drawing.Size(60, 23);
            this.bMap.TabIndex=15;
            this.bMap.Text="Save";
            this.bMap.Click+=new System.EventHandler(this.bMap_Click);
            // 
            // MainForm
            // 
            this.ClientSize=new System.Drawing.Size(594, 395);
            this.Controls.Add(this.bMap);
            this.Controls.Add(this.bCellList);
            this.Controls.Add(this.bDelete);
            this.Controls.Add(this.bCopy);
            this.Controls.Add(this.bMove);
            this.Controls.Add(this.bClearOverlay);
            this.Controls.Add(this.bSDown);
            this.Controls.Add(this.bSUp);
            this.Controls.Add(this.bSRight);
            this.Controls.Add(this.bSLeft);
            this.Controls.Add(this.bOverlay);
            this.Controls.Add(this.MapPanel);
            this.Controls.Add(this.bClose);
            this.Controls.Add(this.bBatch);
            this.Controls.Add(this.bOpen);
            this.Name="MainForm";
            this.Text="TESFaith#";
            this.WindowState=System.Windows.Forms.FormWindowState.Maximized;
            this.Load+=new System.EventHandler(this.MainForm_Load);
            this.ResumeLayout(false);

        }

        #endregion
        #endregion

        private string OpenPlugin=null;
        private RuleType2 CurrentRule=RuleType2.Ignore;


        public MainForm() {
            InitializeComponent();
        }

        private void bOpen_Click(object sender,EventArgs e) {
            OpenModDialog.Multiselect=false;
            if(OpenModDialog.ShowDialog()!=DialogResult.OK) return;
            OpenPlugin=OpenModDialog.FileName;
            bOpen.Enabled=false;
            bClose.Enabled=true;
            bBatch.Enabled=true;
            bCellList.Enabled=true;
            bMove.Enabled=true;
            bCopy.Enabled=true;
            bDelete.Enabled=true;
            UpdateCurrentCells();
            Text="TESFaith# ("+Path.GetFileName(OpenPlugin)+")";
        }

        private void UpdateCurrentCells() {
            if(OpenPlugin==null) MapDrawer.SetActiveCells(null);
            else {
                TESFaith.SetOptions(false,true,false,false,false,true);
                TESFaith.Rules=new ArrayList();
                TESFaith.RunRules(OpenPlugin);
                MapDrawer.SetActiveCells(TESFaith.CellList);
            }
        }

        private void bClose_Click(object sender,EventArgs e) {
            OpenPlugin=null;
            bOpen.Enabled=true;
            bClose.Enabled=false;
            bBatch.Enabled=false;
            bCellList.Enabled=false;
            bMove.Enabled=false;
            bCopy.Enabled=false;
            bDelete.Enabled=false;
            UpdateCurrentCells();
            Text="TESFaith#";
            CurrentRule=RuleType2.Ignore;
        }

        private void bBatch_Click(object sender,EventArgs e) {
            RulesForm rf=new RulesForm();
            if(rf.ShowDialog()!=DialogResult.OK) return;
            TESFaith.Rules=rf.Rules;
            TESFaith.SetOptions(rf.cbVerboseLog.Checked,false,rf.cbModScripts.Checked,rf.cbNewEsp.Checked,
                rf.cbGenLog.Checked,false);
            TESFaith.RunRules(OpenPlugin);
            UpdateCurrentCells();
        }

        private void MainForm_Load(object sender,EventArgs e) {
            MapDrawer.panel=MapPanel;
            MapPanel.SizeChanged+=new EventHandler(MapDrawer.UpdateSize);
            MapDrawer.UpdateSize(null,null);
        }

        private void MapPanel_Paint(object sender,PaintEventArgs e) {
            MapDrawer.PaintMap(e);
        }

        private void bOverlay_Click(object sender,EventArgs e) {
            OpenModDialog.Multiselect=true;
            if(OpenModDialog.ShowDialog()!=DialogResult.OK) return;
            TESFaith.SetOptions(false,true,false,false,false,true);
            foreach(string s in OpenModDialog.FileNames) {
                TESFaith.RunRules(s);
                MapDrawer.AddOverlay(TESFaith.CellList,Path.GetFileName(s));
            }
        }

        private void bClearOverlay_Click(object sender,EventArgs e) {
            MapDrawer.ClearOverlay();
        }

        private void bScrollClick(object sender,EventArgs e) {
            if(sender==bSLeft)
                MapDrawer.Scroll(-1,0);
            else if(sender==bSRight)
                MapDrawer.Scroll(1,0);
            else if(sender==bSUp)
                MapDrawer.Scroll(0,1);
            else if(sender==bSDown)
                MapDrawer.Scroll(0,-1);
        }
        
        private void MapPanel_MouseMove(object sender,MouseEventArgs e) {
            string s;
            MapDrawer.GetMousePos(e.X,e.Y,out s);
            if(s!=null) {
                //ttCellData.Show(s,MapPanel,e.X+16,e.Y+16,5000);
                ttCellData.SetToolTip(MapPanel,s);
            }
        }

        private void MapPanel_MouseLeave(object sender,EventArgs e) {
            //ttCellData.Hide(MapPanel);
            ttCellData.RemoveAll();
        }

        private void MapPanel_MouseDown(object sender,MouseEventArgs e) {
            if(OpenPlugin==null) return;
            if((e.Button&MouseButtons.Right)!=0) {
                CurrentRule=RuleType2.Ignore;
                bMove.BackColor=System.Drawing.SystemColors.Control;
                bCopy.BackColor=System.Drawing.SystemColors.Control;
                bDelete.BackColor=System.Drawing.SystemColors.Control;
            } else if((e.Button&MouseButtons.Left)!=0) {
                int xpos,ypos;
                Rule r;
                MapDrawer.GetCellPos(e.X,e.Y,out xpos,out ypos);
                switch(CurrentRule) {
                    case RuleType2.Move:
                        r=new Rule();
                        r.data.OldX=MapDrawer.SelectedX;
                        r.data.OldY=MapDrawer.SelectedY;
                        r.data.NewX=xpos;
                        r.data.NewY=ypos;
                        r.type2=RuleType2.Move;
                        r.type=RuleType.Cell;
                        TESFaith.Rules=new ArrayList();
                        TESFaith.Rules.Add(r);
                        MapDrawer.Selected=false;
                        TESFaith.SetOptions(false,false,true,false,false,false);
                        TESFaith.RunRules(OpenPlugin);
                        UpdateCurrentCells();
                        break;
                    case RuleType2.Copy:
                        r=new Rule();
                        r.data.OldX=MapDrawer.SelectedX;
                        r.data.OldY=MapDrawer.SelectedY;
                        r.data.NewX=xpos;
                        r.data.NewY=ypos;
                        r.type2=RuleType2.Move;
                        r.type=RuleType.Cell;
                        TESFaith.Rules=new ArrayList();
                        TESFaith.Rules.Add(r);
                        r=new Rule();
                        r.data.OldX=MapDrawer.SelectedX;
                        r.data.OldY=MapDrawer.SelectedY;
                        r.type2=RuleType2.Copy;
                        r.type=RuleType.Cell;
                        TESFaith.Rules.Add(r);
                        MapDrawer.Selected=false;
                        TESFaith.SetOptions(false,false,true,false,false,false);
                        TESFaith.RunRules(OpenPlugin);
                        UpdateCurrentCells();
                        break;
                    case RuleType2.Ignore:
                        if(MapDrawer.CellExists(xpos,ypos)) {
                            MapDrawer.SelectedX=xpos;
                            MapDrawer.SelectedY=ypos;
                            MapDrawer.Selected=true;
                        }
                        break;
                }
                CurrentRule=RuleType2.Ignore;
                bMove.BackColor=System.Drawing.SystemColors.Control;
                bCopy.BackColor=System.Drawing.SystemColors.Control;
                bDelete.BackColor=System.Drawing.SystemColors.Control;
            }
        }

        private void bCellList_Click(object sender,EventArgs e) {
            TESFaith.SetOptions(false,true,false,false,false,false);
            TESFaith.RunRules(OpenPlugin);
        }

        private void bMove_Click(object sender,EventArgs e) {
            if(!MapDrawer.Selected) {
                MessageBox.Show("Select a cell to move first.");
                return;
            }
            CurrentRule=RuleType2.Move;
            bMove.BackColor=System.Drawing.Color.Green;
            bCopy.BackColor=System.Drawing.SystemColors.Control;
            bDelete.BackColor=System.Drawing.SystemColors.Control;
        }

        private void bCopy_Click(object sender,EventArgs e) {
            if(!MapDrawer.Selected) {
                MessageBox.Show("Select a cell to move first.");
                return;
            }
            CurrentRule=RuleType2.Copy;
            bMove.BackColor=System.Drawing.SystemColors.Control;
            bCopy.BackColor=System.Drawing.Color.Green;
            bDelete.BackColor=System.Drawing.SystemColors.Control;
        }

        private void bDelete_Click(object sender,EventArgs e) {
            if(!MapDrawer.Selected) {
                MessageBox.Show("Select a cell to move first.");
                return;
            }
            Rule r=new Rule();
            r.data.OldX=MapDrawer.SelectedX;
            r.data.OldY=MapDrawer.SelectedY;
            r.type2=RuleType2.Delete;
            r.type=RuleType.Cell;
            MapDrawer.Selected=false;
            TESFaith.Rules=new ArrayList();
            TESFaith.Rules.Add(r);
            TESFaith.SetOptions(false,false,false,false,false,false);
            TESFaith.RunRules(OpenPlugin);
            CurrentRule=RuleType2.Ignore;
            bMove.BackColor=System.Drawing.SystemColors.Control;
            bCopy.BackColor=System.Drawing.SystemColors.Control;
            bDelete.BackColor=System.Drawing.SystemColors.Control;
            UpdateCurrentCells();
        }

        private void bMap_Click(object sender, EventArgs e) {
            if(SaveMapDialog.ShowDialog()==DialogResult.OK) {
                MapDrawer.SaveMap(SaveMapDialog.FileName,SaveMapDialog.FilterIndex);
            }
        }

    }
}
